Package icyllis.modernui.transition

# Class Fade

java.lang.Object
icyllis.modernui.transition.Transition
icyllis.modernui.transition.Visibility
icyllis.modernui.transition.Fade

All Implemented Interfaces:
  `Cloneable`

public class Fade extends Visibility
This transition tracks changes to the visibility of target views in the start and end scenes and fades views in or out when they become visible or non-visible. Visibility is determined by both the `View.setVisibility(int)` state of the view as well as whether it is parented in the current view hierarchy.

The ability of this transition to fade out a particular view, and the way that that fading operation takes place, is based on the situation of the view in the view hierarchy. For example, if a view was simply removed from its parent, then the view will be added into a

invalid reference

    ViewGroupOverlay

while fading. If a visible view is changed to be `View.GONE` or `View.INVISIBLE`, then the visibility will be changed to `View.VISIBLE` for the duration of the animation. However, if a view is in a hierarchy which is also altering its visibility, the situation can be more complicated. In general, if a view that is no longer in the hierarchy in the end scene still has a parent (so its parent hierarchy was removed, but it was not removed from its parent), then it will be left alone to avoid side-effects from improperly removing it from its parent.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class icyllis.modernui.transition.Visibility

  `Visibility.Mode`

  ## Nested classes/interfaces inherited from class icyllis.modernui.transition.Transition

  `Transition.EpicenterCallback, Transition.MatchOrder`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `IN`
  Fading mode used in `Fade(int)` to make the transition operate on targets that are appearing.
  `static final int`
  `OUT`
  Fading mode used in `Fade(int)` to make the transition operate on targets that are disappearing.

  ### Fields inherited from class icyllis.modernui.transition.Visibility

  `MODE_IN, MODE_OUT`

  ### Fields inherited from class icyllis.modernui.transition.Transition

  `MATCH_ID, MATCH_INSTANCE, MATCH_ITEM_ID, MATCH_NAME`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Fade()`
  Constructs a Fade transition that will fade targets in and out.
  `Fade(int fadingMode)`
  Constructs a Fade transition that will fade targets in and/or out, according to the value of fadingMode.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `captureStartValues(TransitionValues transitionValues)`
  Captures the values in the start scene for the properties that this transition monitors.
  `Animator`
  `onAppear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)`
  The default implementation of this method returns a null Animator.
  `Animator`
  `onDisappear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)`
  The default implementation of this method returns a null Animator.

  ### Methods inherited from class icyllis.modernui.transition.Visibility

  `captureEndValues, createAnimator, getMode, getTransitionProperties, isTransitionRequired, isVisible, onAppear, onDisappear, setMode`

  ### Methods inherited from class icyllis.modernui.transition.Transition

  `addListener, addTarget, addTarget, addTarget, addTarget, animate, cancel, clone, createAnimators, end, excludeChildren, excludeChildren, excludeChildren, excludeTarget, excludeTarget, excludeTarget, excludeTarget, getDuration, getEpicenter, getEpicenterCallback, getInterpolator, getName, getPropagation, getStartDelay, getTargetIds, getTargetNames, getTargets, getTargetTypes, getTransitionValues, pause, removeListener, removeTarget, removeTarget, removeTarget, removeTarget, resume, runAnimators, setDuration, setEpicenterCallback, setInterpolator, setMatchOrder, setPropagation, setStartDelay, start, toString`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### IN

    public static final int IN
    Fading mode used in `Fade(int)` to make the transition operate on targets that are appearing. Maybe be combined with `OUT` to fade both in and out.
    See Also:
      - Constant Field Values

  - ### OUT

    public static final int OUT
    Fading mode used in `Fade(int)` to make the transition operate on targets that are disappearing. Maybe be combined with `IN` to fade both in and out.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Fade

    public Fade()
    Constructs a Fade transition that will fade targets in and out.

  - ### Fade

    public Fade(int fadingMode)
    Constructs a Fade transition that will fade targets in and/or out, according to the value of fadingMode.
    Parameters:
      `fadingMode` - The behavior of this transition, a combination of `IN` and `OUT`.

- ## Method Details

  - ### captureStartValues

    public void captureStartValues(@Nonnull TransitionValues transitionValues)
    Description copied from class: `Transition`
    Captures the values in the start scene for the properties that this transition monitors. These values are then passed as the startValues structure in a later call to `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`. The main concern for an implementation is what the properties are that the transition cares about and what the values are for all of those properties. The start and end values will be compared later during the `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)` method to determine what, if any, animations, should be run.

    Subclasses must implement this method. The method should only be called by the transition system; it is not intended to be called from external classes.

    Overrides:
      `captureStartValues` in class `Visibility`
    Parameters:
      `transitionValues` - The holder for any values that the Transition wishes to store. Values are stored in the `values` field of this TransitionValues object and are keyed from a String value. For example, to store a view's rotation value, a transition might call `transitionValues.values.put("appname:transitionname:rotation", view.getRotation())`. The target view will already be stored in the transitionValues structure when this method is called.
    See Also:
      - `Transition.captureEndValues(TransitionValues)`
      - `Transition.createAnimator(ViewGroup, TransitionValues, TransitionValues)`

  - ### onAppear

    @Nullable public Animator onAppear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)
    Description copied from class: `Visibility`
    The default implementation of this method returns a null Animator. Subclasses should override this method to make targets appear with the desired transition. The method should only be called from `Visibility.onAppear(ViewGroup, TransitionValues, int, TransitionValues, int)`.
    Overrides:
      `onAppear` in class `Visibility`
    Parameters:
      `sceneRoot` - The root of the transition hierarchy
      `view` - The View to make appear. This will be in the target scene's View hierarchy and will be VISIBLE.
      `startValues` - The target values in the start scene
      `endValues` - The target values in the end scene
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.

  - ### onDisappear

    @Nullable public Animator onDisappear(ViewGroup sceneRoot, View view, TransitionValues startValues, TransitionValues endValues)
    Description copied from class: `Visibility`
    The default implementation of this method returns a null Animator. Subclasses should override this method to make targets disappear with the desired transition. The method should only be called from `Visibility.onDisappear(ViewGroup, TransitionValues, int, TransitionValues, int)`.
    Overrides:
      `onDisappear` in class `Visibility`
    Parameters:
      `sceneRoot` - The root of the transition hierarchy
      `view` - The View to make disappear. This will be in the target scene's View hierarchy and will be VISIBLE.
      `startValues` - The target values in the start scene
      `endValues` - The target values in the end scene
    Returns:
      An Animator to be started at the appropriate time in the overall transition for this scene change. A null value means no animation should be run.